您的位置:首页 > 产品设计 > UI/UE

LeetCode - TwoSumII - Frequent

2015-03-12 22:41 176 查看
Two Sum II, 是leetcode付费的部分,在这里贴下题目吧,这样不想付费的也可以看看,非常简单,比two sum还简单:

https://leetcode.com/problems/two-sum-ii-input-array-is-sorted/

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

代码就是两边逼近,因为这里不需要排序,所以也不用hashmap来记录index,直接两边逼近就行了

public int[] twoSum(int[] numbers, int target) {
int[] rst = new int[2];
int start = 0;
int end = numbers.length-1;
while(start<end){
if((numbers[start]+numbers[end])==target){
rst[0]=start+1;
rst[1]=end+1;
return rst;
}
else if((numbers[start]+numbers[end])<target) start++;
else if((numbers[start]+numbers[end])>target) end--;
}
return rst;
}


空间复杂度O(1), 时间复杂度O(n)

看了一下leetcode给的tag,这还可以用binary search的解法,不过我目前觉得需要O(n*lgn)的时间,所以这里不写binary search的解法了
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: